//   CO2 MH-Z19
//   9600,8,N,1
//       FF 01 86 00 00 00 00 00 (  (CRC=$79)   )
//    FF 86 03 B0 3F 04 2A E4 76 ($03B0= CO2 (ppm), $3F=+40, $76=CRC)

var
  sbuf: string;
  lasttick: cardinal;

procedure OnLoad();
begin
  SetV('APGD', '0'); //       
end;

function CountCRC(const s: string): char;
var
  i: integer;
  b: byte;
begin
  b := 0;
  for i := 1 to length(s) do 
    b := b + ord(s[i]);
  Result := chr(not(b));
end;

procedure OnReceive();
var
  i: integer;
begin
  if (GetTickCount() - lastTick > 1000) or (length(sbuf) > 100) then
    sbuf := '';
  lastTick := GetTickCount();
  for i := 1 to length(RD) do begin
    if sbuf = '' then
      if RD[i] <> #$FF then continue;
    sbuf := sbuf + RD[i];
    if length(sbuf) = 9 then begin
      if CountCRC(copy(sbuf, 1, 8)) = sbuf[9] then
        GraphAdd(ord(sbuf[3])*256 + ord(sbuf[4]));
      sbuf := '';
    end;
  end;
end;

procedure OnSend();
begin
  TD := TD + CountCRC(TD);
end;